#include "ComPort.h"







 HANDLE ComPort::StartThread(LPTHREAD_METHOD pMethod, LPVOID pParam,
                              LPDWORD pdwThreadID /* = NULL */,
                              LPSECURITY_ATTRIBUTES pSecurity /* = NULL */,
                              DWORD dwStackSize /* = 0 */,
                              DWORD dwFlags /* = 0 */)
 {
     //        .
     LPSTARTUP_PARAM pStartup = new STARTUP_PARAM;
     pStartup->pClass    = this;
     pStartup->pMethod    = pMethod;
     pStartup->pParam    = pParam;

     //   .
     return CreateThread(pSecurity, dwStackSize, (LPTHREAD_START_ROUTINE)StartFunc, pStartup, dwFlags, pdwThreadID);
 }
 







void ComPort::ComStart()
{
	std::wstring comnum = L"COM4";
    std::string data = "\n 010400 \n";

    //unsigned int length = 0;
    DCB config = {0};

	
	
	COMMTIMEOUTS CommTimeOuts;
	m_hCommPort = ::CreateFile(comnum.c_str(),
        GENERIC_READ|GENERIC_WRITE,//access ( read and write)

        1,    //(share) 0:cannot share the COM port                        

        0,    //security  (None)                

        OPEN_EXISTING,// creation : open_existing

        FILE_FLAG_OVERLAPPED,    // we dont want overlapped operation
		//0, // 0

        0// no templates file for COM port...

        );

    config.DCBlength = sizeof(config);


    if((GetCommState(m_hCommPort, &config) == 0))
    {
        std::cout << "Get configuration port has a problem.";
       // return FALSE;
    }

    config.BaudRate = 9600;
    config.StopBits = ONESTOPBIT;
    config.Parity = PARITY_NONE; 
    config.ByteSize = DATABITS_8;
    config.fDtrControl = 0;
    config.fRtsControl = 0;

    if (!SetCommState(m_hCommPort, &config)) // 
    {
		std::cout << "Failed to Set Comm State Reason: %d\n"<<GetLastError();
       // return E_FAIL;
    }

    std::cout << "Current Settings\n Baud Rate "<< config.BaudRate<<" \n Parity "<< 
        config.Parity<<" \n Byte Size "<< config.ByteSize<<"\n Stop Bits "<< 
         config.StopBits<< std::endl;

	if (GetLastError()){std::cout << "LastError 9="<< GetLastError() << std::endl;}
	std::cout << "LastError zz="<< GetLastError() << std::endl;

	CommTimeOuts.ReadIntervalTimeout= 3; 
	CommTimeOuts.ReadTotalTimeoutMultiplier = 8; 
	//           
	//    110  
	CommTimeOuts.ReadTotalTimeoutConstant = 50; //         
	CommTimeOuts.WriteTotalTimeoutMultiplier = 0; 
	CommTimeOuts.WriteTotalTimeoutConstant = 0; 
	SetCommTimeouts(m_hCommPort, &CommTimeOuts);
	if (GetLastError()){std::cout << "LastError 10="<< GetLastError() << std::endl;}

	PurgeComm(m_hCommPort, PURGE_RXCLEAR); //       ,          .
	PurgeComm(m_hCommPort, PURGE_TXCLEAR);
	if (GetLastError()){std::cout << "LastError 11="<< GetLastError() << std::endl;}

}

DWORD  ComPort::ComRead(LPVOID pParam) 
{
//char output[10];
DWORD  state = 1, temp,btr=0;
int res=0;

/*      */
res=SetCommMask(m_hCommPort, EV_RXCHAR);
if (!res)   { std::cout << "SetCommMask1 error!"<< std::endl; } else {std::cout << "SetCommMask1 res="<<res<< std::endl;}
if (GetLastError()){std::cout << "LastError 17="<< GetLastError() << std::endl;}

DWORD EMask;
res=GetCommMask( // ()  
				m_hCommPort,
				&EMask
				);
		if (res)
			{}
		else{std::cout << "GetCommMask1 error! res="<<res<<" "<< GetLastError() << std::endl;}

/*    */
overlapped.hEvent = CreateEvent(NULL, true, true, NULL);
if (GetLastError()){std::cout << "LastError 16="<< GetLastError() << std::endl;}
COMSTAT comstat;		//   ,    
				//      
//http://www.piclist.ru/S-COM-THREAD-RUS/S-COM-THREAD-RUS.html

while (1) // .    output[10];
//for (int i=0; i<15; i++)
{
//	std::cout << "OTL 1 state="<< state << std::endl;
	Sleep(3);

	WaitCommEvent(m_hCommPort, &state, &overlapped);//   
//	if (GetLastError()){std::cout << "LastError 18="<< GetLastError() << std::endl;}
	
	
		
	//WaitForSingleObject(overlapped.hEvent, INFINITE);	//    
//		std::cout << "OTL 2 state="<< state << std::endl;
	//   if(signal == WAIT_OBJECT_0)				        //    
	if(state & EV_RXCHAR) //     
	{ }
	else
	{std::cout << "Not EV_RXCHAR! ="  << " state="<< state << std::endl;}

//	std::cout << "OTL 3 ="<< btr << std::endl;
	   if(GetOverlappedResult(m_hCommPort, &overlapped, &temp, true)) //,   
		{														  //  WaitCommEvent
//			  std::cout << "OTL 4 ="<< btr << std::endl;
			   {
				   //if( EV_RXCHAR!=0)				//     
					//{
				   ClearCommError(m_hCommPort, &temp, &comstat);		//   COMSTAT
				btr = comstat.cbInQue;                          	//      
//				std::cout << "btr ="<< btr << std::endl;
					if(btr)                         			//     
						{
						ReadFile(m_hCommPort, output, sizeof(output), &dwBytesRead, &overlapped);     //      
						//Sleep(2);
						//std::cout<< std::endl << "isRead ="<< output[0] << output[1] << output[2] << output[3]<< output[4]<< output[5]<< output[6]<< output[7]<< output[8]<< output[9]  << std::endl<< std::endl;
						//}
					}
				}
        }
	   else 
	     {
//			 std::cout << "Overlapped not happy! ="  << " dwBytesRead="<< dwBytesRead << std::endl;
	     }
	
}
 CloseHandle(overlapped.hEvent);		//     -
   
    return  0;
}

















 void ComPort::ComWrite(std::string input)
{
//	char buf[10]=input.c_str();
//	input.c_str()=+char(19);
	int le=sizeof(input.c_str());
//cout<<"WriteFileMethod 0 len="<< le<< " "<<input.c_str() <<endl;

DWORD dwBytesWrite;//  
//cout<<"WriteFileMethod1="<< input.c_str() <<endl;
WriteFile(m_hCommPort, input.c_str(), le-1, &dwBytesWrite, &overlapped);     //      
//WriteFile(m_hCommPort, input.c_str(), sizeof(input.c_str()), &dwBytesWrite, &overlapped);     //      

//			cout<<"WriteFileMethodEnd"<<endl;
			Sleep(10);
}




 //       CMyClass::StartFunc(...)
 //     .
 DWORD ComPort::StartFunc(LPSTARTUP_PARAM pStartup)
 {
     //     .
     //        .
     ComPort* pClass        = pStartup->pClass;
     LPTHREAD_METHOD pMethod = pStartup->pMethod;
     LPVOID pParam            = pStartup->pParam;
 
     //      .
     DWORD dwResult = (pClass->*pMethod)(pParam);

	 //          .
     delete pStartup;
     return dwResult;
  }



  DWORD ComPort::Process(LPVOID pParam)
 
 {
   	 while(1)
			{
			cout<<"Potok threadMethod"<<endl;
			Sleep(1000);
			}
     return 0;
 }